class Circle{
  
  PVector pos;
  PVector dragOffset;
  int milliz;
  color col, col1;
  
  boolean show;
  
  float cdiam, diam, rad;
  float r,g,b;
  float snapx = ((linea.maxx-linea.minx)/8)/2;
  float snapy = ((linea.bottomLimit-10-linea.topLimit-10)/10)/2;

  Circle(float px, float py) {
    pos = new PVector(px, py);
    dragOffset = new PVector();
    diam = 35;
    rad = diam / 2;
    show = false;
    r=0;
    g=random(60,125);
    b=random(40,160);
    col = color(r,g,b);
    col1 = color(r+50,g+50,b+50);
  }

  boolean isInside(float px, float py) {
    boolean b = dist(px, py, pos.x, pos.y) < rad;
    dragOffset = new PVector(px - pos.x, py - pos.y);
    return b;
  }
  
  void draw(float px, float py) {
    if (isInside(px, py)) {
      fill(col,200);
    } 
    else {
      fill(col1,220);
    }
    pushStyle();
    strokeWeight(2);
    noStroke();
    cdiam += (diam - cdiam) * 0.08;
    ellipse(pos.x, pos.y,cdiam, cdiam);
    
    if (show) {
      
      fill(col);
      ellipse(pos.x, pos.y,10, 10);

    }
    
       if (pos.x > width-rad) pos.x = width-rad;
    if (pos.x < 0) pos.x = 0;
    if (pos.y > height-rad) pos.y = height-rad;
    if (pos.y < 0) pos.y = 0;
    
    if(snappx) {
      for (int i=0; i<9; i++) {
        if ((pos.x > (linea.minx+i*((linea.maxx-linea.minx)/8))-snapx) && (pos.x < (linea.minx+i*((linea.maxx-linea.minx)/8))+snapx)) {
        pos.x = linea.minx+i*((linea.maxx-linea.minx)/8);
        }
      }
    }
    if(snappy) {  
      for (int i=0; i<11; i++) {
        if ((pos.y > (linea.topLimit+10+i*((linea.bottomLimit-10-linea.topLimit-10)/10)-snapy)) && (pos.y < linea.topLimit+10+i*((linea.bottomLimit-10-linea.topLimit-10)/10)+snapy)) {
        pos.y = linea.topLimit+10+i*((linea.bottomLimit-10-linea.topLimit-10)/10);
        }
      }
     
    }
    
    
  }
  
  void setPosition(float px, float py) {
    pos.x = px - dragOffset.x;
    pos.y = py - dragOffset.y;
  }
  
}

