class Crossa {

  PVector pos = new PVector();
  float l;
  float r, d;
  float cd;
  boolean crozza;

  Crossa(float _x, float _y, boolean _crozza) {
    pos.x = _x;
    pos.y = _y;
    l = 20;
    d = 40;
    r = d/2;
    cd = 100;
    crozza = _crozza;
  }

  void display() {
    if (!crozza) {
      noStroke();
      fill(255, 80, 80);
      ellipse(pos.x, pos.y, cd, cd);
    } 
    else {
      noFill();
      stroke(255,0,0);
      strokeWeight(7);
      line(pos.x-l/2, pos.y-l/2, pos.x+l/2, pos.y+l/2);
      line(pos.x-l/2, pos.y+l/2, pos.x+l/2, pos.y-l/2);
    }
  }

  void inflate() {
      l = abs((cos(frameCount*0.06)+3) * 6)+1;
      r = abs((cos(frameCount*0.02)+3.5) * 6)+1;
    cd += (d - cd) * 2;
  }

  boolean isInside(float px, float py) {
    boolean b = dist(px, py, pos.x, pos.y) < cd/2;
    return b;
  }
  
   boolean isInsideCross(float px, float py) {
    boolean b = dist(px, py, pos.x, pos.y) < l;
    return b;
  }
}

